## libjdns 2.0.3

=== CMakeLists.txt ===
project(jdns)

cmake_minimum_required(VERSION 2.8.11)
cmake_policy(SET CMP0003 NEW)

# Do not link against qtmain on Windows
cmake_policy(SET CMP0020 OLD)

# On Windows debug library should have 'd' postfix.
if(WIN32)
  set(CMAKE_DEBUG_POSTFIX "d")
elseif(APPLE)
 set(CMAKE_DEBUG_POSTFIX "_debug")
endif(WIN32)

# jdns can be used as bundled in this case need to explicity disable automoc
# to avoid duplicates of mocked files
set(CMAKE_AUTOMOC OFF)


# OPTION(OSX_FRAMEWORK "Build a Mac OS X Framework")
# SET(FRAMEWORK_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/Library/Frameworks"
#     CACHE PATH "Where to place jdns.framework if OSX_FRAMEWORK is selected")

option(BUILD_SHARED_LIBS "Build shared library" ON)
option(BUILD_QJDNS "Buid JDNS Qt-wrapper" ON)
option(BUILD_JDNS_TOOL "Build jdns test tool" ON)

# jdns tool requires qjdns
if(NOT BUILD_QJDNS)
  set(BUILD_JDNS_TOOL OFF)
endif(NOT BUILD_QJDNS)

if(NOT BUILD_SHARED_LIBS)
  add_definitions(-DJDNS_STATIC)
endif(NOT BUILD_SHARED_LIBS)

if(BUILD_QJDNS)
  option(QT4_BUILD "Force building with Qt4 even if Qt5 is found")
  # On Linux in most cases (or always) can be cointstalled both Qt4 and Qt5.
  # Need to provide two versions of qjdns are Qt4 and Qt5-based.
  if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
    option(MULTI_QT "Consider multiple Qt version on the system (add suffixes)" ON)
  else()
    option(MULTI_QT "Consider multiple Qt version on the system (add suffixes)" OFF)
  endif()

  if(NOT QT4_BUILD)
    find_package(Qt5Core QUIET)
    find_package(Qt5Network QUIET)
  endif(NOT QT4_BUILD)

  if(Qt5Core_FOUND)
    message("Qt5 found")

    include_directories(${Qt5Core_INCLUDE_DIRS})
    include_directories(${Qt5Network_INCLUDE_DIRS})
    add_definitions(${Qt5Core_DEFINITIONS})
    add_definitions(${Qt5Network_DEFINITIONS})

    # Tell CMake to run moc when necessary:
    set(CMAKE_AUTOMOC ON)
    # As moc files are generated in the binary dir, tell CMake
    # to always look for includes there:
    set(CMAKE_INCLUDE_CURRENT_DIR ON)
    set(QJDns_QT_PC_VERSION "Qt5Core Qt5Network")
    set(QT_MAJ "-qt5")
  else(Qt5Core_FOUND)
    message("Qt5 not found, searching for Qt4")
    # Find Qt4
    find_package(Qt4 REQUIRED QtCore QtNetwork)

    # Include the cmake file needed to use qt4
    include(${QT_USE_FILE})
    set(QJDns_QT_PC_VERSION "QtCore QtNetwork")
    set(QT_MAJ "-qt4")
  endif(Qt5Core_FOUND)

  if(NOT WIN32)
    set(QT_DONT_USE_QTGUI TRUE)
  endif(NOT WIN32)

  if(NOT MULTI_QT)
    set(QT_MAJ "")
  endif(NOT MULTI_QT)
endif(BUILD_QJDNS)


# put the include dirs which are in the source or build tree
# before all other include dirs, so the headers in the sources
# are prefered over the already installed ones
set(CMAKE_INCLUDE_DIRECTORIES_PROJECT_BEFORE ON)

set(JDNS_INCLUDEDIR "${CMAKE_CURRENT_SOURCE_DIR}/include/jdns" )


#add extra search paths for libraries and includes
set(LIB_SUFFIX "" CACHE STRING "Define suffix of directory name (32/64)" )
set(BIN_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/bin" CACHE STRING "Directory where binary will install")
set(LIB_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}" CACHE STRING "Directory where library will install")
set(INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/include" CACHE PATH "The directory the headers are installed in")

set(LIB_INSTALL_DIR_FULL "${LIB_INSTALL_DIR}")
set(INCLUDE_INSTALL_DIR_FULL "${INCLUDE_INSTALL_DIR}")

# Normalize paths for comparsion
get_filename_component(CMAKE_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX} ABSOLUTE)
get_filename_component(BIN_INSTALL_DIR ${BIN_INSTALL_DIR} ABSOLUTE)
get_filename_component(LIB_INSTALL_DIR ${LIB_INSTALL_DIR} ABSOLUTE)
get_filename_component(INCLUDE_INSTALL_DIR ${INCLUDE_INSTALL_DIR} ABSOLUTE)

# if all paths are subdirs of CMAKE_INSTALL_PREFIX it is possible to use relative paths
set(USE_RELATIVE_PATHS ON)
foreach(PATH ${BIN_INSTALL_DIR} ${LIB_INSTALL_DIR} ${INCLUDE_INSTALL_DIR})
  string(FIND "${PATH}/" "${CMAKE_INSTALL_PREFIX}/" POS)
  if(NOT "${POS}" STREQUAL "0")
    set(USE_RELATIVE_PATHS OFF)
  endif()
endforeach()

if(USE_RELATIVE_PATHS)
  file(RELATIVE_PATH BIN_INSTALL_DIR ${CMAKE_INSTALL_PREFIX} ${BIN_INSTALL_DIR})
  file(RELATIVE_PATH LIB_INSTALL_DIR ${CMAKE_INSTALL_PREFIX} ${LIB_INSTALL_DIR})
  file(RELATIVE_PATH INCLUDE_INSTALL_DIR ${CMAKE_INSTALL_PREFIX} ${INCLUDE_INSTALL_DIR})
endif()

if(NOT MSVC)
  set(JDNS_CONFIG_INSTALL_DIR "${LIB_INSTALL_DIR}/cmake/jdns")
  set(QJDNS_CONFIG_INSTALL_DIR "${LIB_INSTALL_DIR}/cmake/qjdns${QT_MAJ}")
  set(QJDNS_COMMON_CONFIG_INSTALL_DIR "${LIB_INSTALL_DIR}/cmake/qjdns")
else(NOT MSVC)
  set(JDNS_CONFIG_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/cmake/")
  set(QJDNS_CONFIG_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/cmake/")
  set(QJDNS_COMMON_CONFIG_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/cmake/")
endif(NOT MSVC)

if(APPLE)
   set(CMAKE_INSTALL_NAME_DIR ${LIB_INSTALL_DIR})
endif(APPLE)

set(JDNS_LIB_MAJOR_VERSION "2")
set(JDNS_LIB_MINOR_VERSION "0")
set(JDNS_LIB_PATCH_VERSION "3")

set(JDNS_LIB_VERSION_STRING "${JDNS_LIB_MAJOR_VERSION}.${JDNS_LIB_MINOR_VERSION}.${JDNS_LIB_PATCH_VERSION}")

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin" )
# Use the same path for shared and static library
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib" )
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib" )


# pkg-config
if(NOT WIN32)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/jdns.pc.in
                 ${CMAKE_CURRENT_BINARY_DIR}/jdns.pc
                 @ONLY)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/jdns.pc
          DESTINATION ${LIB_INSTALL_DIR}/pkgconfig)

  if(BUILD_QJDNS)
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/qjdns.pc.in
                   ${CMAKE_CURRENT_BINARY_DIR}/qjdns${QT_MAJ}.pc
                   @ONLY)
  endif(BUILD_QJDNS)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/qjdns${QT_MAJ}.pc
          DESTINATION ${LIB_INSTALL_DIR}/pkgconfig)
endif(NOT WIN32)

include_directories("include/jdns/")

# Subdirs
add_subdirectory(src)

if(BUILD_JDNS_TOOL)
  add_subdirectory(tools/jdns)
endif(BUILD_JDNS_TOOL)

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)

# cmake-modules
include(CMakePackageConfigHelpers)
configure_package_config_file(
  JDnsConfig.cmake.in
  "${CMAKE_CURRENT_BINARY_DIR}/JDnsConfig.cmake"
  INSTALL_DESTINATION ${JDNS_CONFIG_INSTALL_DIR}
  PATH_VARS BIN_INSTALL_DIR
            LIB_INSTALL_DIR
            INCLUDE_INSTALL_DIR)

write_basic_config_version_file(JDnsConfigVersion.cmake VERSION ${JDNS_LIB_VERSION_STRING} COMPATIBILITY AnyNewerVersion)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/JDnsConfig.cmake
              ${CMAKE_CURRENT_BINARY_DIR}/JDnsConfigVersion.cmake
        DESTINATION ${JDNS_CONFIG_INSTALL_DIR})

install(EXPORT jdns-export DESTINATION ${JDNS_CONFIG_INSTALL_DIR} FILE JDnsTargets.cmake)
if(BUILD_QJDNS)
  install(EXPORT qjdns-export DESTINATION ${QJDNS_CONFIG_INSTALL_DIR} FILE QJDns${QT_MAJ}Targets.cmake)

  # cmake-modules
  configure_package_config_file(
    QJDns-qtConfig.cmake.in
    "${CMAKE_CURRENT_BINARY_DIR}/QJDns${QT_MAJ}Config.cmake"
    INSTALL_DESTINATION ${QJDNS_CONFIG_INSTALL_DIR})

  write_basic_config_version_file(QJDns${QT_MAJ}ConfigVersion.cmake VERSION ${JDNS_LIB_VERSION_STRING} COMPATIBILITY AnyNewerVersion)

  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/QJDns${QT_MAJ}Config.cmake
                ${CMAKE_CURRENT_BINARY_DIR}/QJDns${QT_MAJ}ConfigVersion.cmake
          DESTINATION ${QJDNS_CONFIG_INSTALL_DIR})

  # Install QJDns config module which will automagically choose correct building of QJDns
  if(MULTI_QT)
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/QJDnsConfig.cmake.in
                   ${CMAKE_CURRENT_BINARY_DIR}/QJDnsConfig.cmake
                   COPYONLY)

    write_basic_config_version_file(QJDnsConfigVersion.cmake VERSION ${JDNS_LIB_VERSION_STRING} COMPATIBILITY AnyNewerVersion)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/QJDnsConfig.cmake
                  ${CMAKE_CURRENT_BINARY_DIR}/QJDnsConfigVersion.cmake
            DESTINATION ${QJDNS_COMMON_CONFIG_INSTALL_DIR})
  endif()

endif(BUILD_QJDNS)

add_custom_target(uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

=== debian/changelog ===
libjdns (2.0.3-4) unstable; urgency=medium

  * QA upload.
  * Fix FTBFS with CMake 4. (Closes: #1113162)
  * debian/control: Update Homepage.

 -- Adrian Bunk <bunk@debian.org>  Mon, 27 Oct 2025 19:51:40 +0200

libjdns (2.0.3-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062384

 -- Benjamin Drung <bdrung@debian.org>  Wed, 28 Feb 2024 13:28:30 +0000

libjdns (2.0.3-3) unstable; urgency=medium

  * QA upload.
  * debian/rules: Pass -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON to
    dh_auto_configure.
  * debian/control: Set Rules-Requires-Root to "no".
  * debian/control: Update Standards-Version to 4.6.1.

 -- Vagrant Cascadian <vagrant@reproducible-builds.org>  Sun, 10 Jul 2022 18:32:46 -0700

libjdns (2.0.3-2) unstable; urgency=medium

  * QA upload.
  * debian/control:
    + Bump debhelper compat to v13.
    + Apply "wrap-and-sort -abst".
    + Orphan the package.
    + Bump Standards-Version to 4.6.0.
    + Fix Vcs-* fields.
    + Minor package description fix. (Closes: #832002)
  * debian/: Drop manual -dbg packages.

 -- Boyuan Yang <byang@debian.org>  Sun, 27 Mar 2022 17:53:14 -0400

libjdns (2.0.3-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Drop Qt4 packages (Closes: #875022)

 -- Moritz Muehlenhoff <jmm@debian.org>  Sat, 07 Sep 2019 22:44:50 +0200

libjdns (2.0.3-1) unstable; urgency=low

  * Initial release to Debian. (Closes: #804275)

 -- Stefan Ahlers <stef.ahlers@t-online.de>  Tue, 17 Nov 2015 17:50:00 +0100

=== debian/control ===
Source: libjdns
Section: libs
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: dpkg-dev (>= 1.22.5),
 cmake,
 debhelper-compat (= 13),
 qtbase5-dev,
Standards-Version: 4.6.1
Rules-Requires-Root: no
Homepage: https://github.com/psi-im/jdns
Vcs-Git: https://salsa.debian.org/debian/libjdns.git
Vcs-Browser: https://salsa.debian.org/debian/libjdns

Package: jdns
Section: misc
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: command-line tool to test functionality
 Qt5-based command-line tool called 'jdns' that can be used to test
 DNS functionality.

Package: libjdns-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libjdns2t64 (= ${binary:Version}),
 ${misc:Depends},
Description: Simple DNS queries library - development files
 JDNS is a simple DNS implementation that can perform normal DNS
 queries of any record type (notably SRV), as well as Multicast DNS
 queries and advertising. Multicast support is based on Jeremie
 Miller's "mdnsd" implementation.
 .
 The libjdns-dev package contains libraries and header files for
 developing applications that use jdns.

Package: libjdns2t64
Provides: ${t64:Provides}
Replaces: libjdns2
Breaks: libjdns2 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Simple DNS queries library
 JDNS is a simple DNS implementation that can perform normal DNS
 queries of any record type (notably SRV), as well as Multicast DNS
 queries and advertising. Multicast support is based on Jeremie
 Miller's "mdnsd" implementation.

Package: libqjdns-qt5-2t64
Provides: ${t64:Provides}
Replaces: libqjdns-qt5-2
Breaks: libqjdns-qt5-2 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Simple DNS queries library  - Qt5 wrapper
 For Qt5 users there is a wrapper available called QJDns and a very
 high-level wrapper called QJDnsShared (under its original name
 JDnsShared).

Package: libqjdns-qt5-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libqjdns-qt5-2t64 (= ${binary:Version}),
 ${misc:Depends},
Description: Simple DNS queries library Qt5 wrapper - development files
 JDNS is a simple DNS implementation that can perform normal DNS
 queries of any record type (notably SRV), as well as Multicast DNS
 queries and advertising.
 .
 The libqjdns-qt5-dev package contains libraries and header files for
 developing Qt5 applications that use qjdns.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND =

include /usr/share/dpkg/default.mk
QT5_PATH = build/qt5/so

%:
	dh $@

override_dh_auto_configure:
	mkdir -p $(QT5_PATH)
	dh_auto_configure -B$(QT5_PATH) -- -DLIB_SUFFIX=/$(DEB_HOST_MULTIARCH) -DMULTI_QT=ON -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON

override_dh_auto_build:
	QT_SELECT=qt5 dh_auto_build -B$(QT5_PATH)

override_dh_auto_clean:
	dh_auto_clean -B$(QT5_PATH)

override_dh_auto_install:
	dh_auto_install -B$(QT5_PATH)

override_dh_strip:
	dh_strip --dbgsym-migration='jdns-dbg (<< 2.0.3-2~), libjdns-dbg (<< 2.0.3-2~), libqjdns-qt5-dbg (<< 2.0.3-2~)'

=== debian/watch ===
version=3
http://delta.affinix.com/download/jdns-(.+).tar.bz2
